=== modified file 'bzrlib/strace.py'
--- bzrlib/strace.py	2010-09-01 18:43:13 +0000
+++ bzrlib/strace.py	2010-09-01 19:38:55 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2009, 2010 Canonical Ltd
+# Copyright (C) 2007 Canonical Ltd
 #   Authors: Robert Collins <robert.collins@canonical.com>
 #
 # This program is free software; you can redistribute it and/or modify

=== modified file 'bzrlib/tests/stub_sftp.py'
--- bzrlib/tests/stub_sftp.py	2010-09-01 18:41:31 +0000
+++ bzrlib/tests/stub_sftp.py	2010-09-01 19:38:55 +0000
@@ -339,31 +339,12 @@
         return bytes_sent
 
 
-class TransportWithStopEvent(paramiko.Transport):
-    """Identical to a regular paramiko.Transport
-
-    except when the main thread is finished processing events, we set an event,
-    so that the rest of the code can wait for it.
-    """
-
-    def __init__(self, *args, **kwargs):
-        super(TransportWithStopEvent, self).__init__(*args, **kwargs)
-        self.stopped_event = threading.Event()
-
-    def run(self):
-        self.stopped_event.clear()
-        try:
-            super(TransportWithStopEvent, self).run()
-        finally:
-            self.stopped_event.set()
-
-
 class TestingSFTPConnectionHandler(SocketServer.BaseRequestHandler):
 
     def setup(self):
         self.wrap_for_latency()
         tcs = self.server.test_case_server
-        ssh_server = TransportWithStopEvent(self.request)
+        ssh_server = paramiko.Transport(self.request)
         # Set it to a channel under 'bzr' so that we get debug info
         ssh_server.set_log_channel('bzr.paramiko.transport')
         ssh_server.add_server_key(tcs.get_host_key())
@@ -373,29 +354,9 @@
         server = tcs._server_interface(tcs)
         # This blocks until the key exchange has been done
         ssh_server.start_server(None, server)
-        # Continue blocking until the run() loop has completed, this sets an
-        # upper bound on how long a test can take, but 5s is pretty long, and
-        # we don't really want to wait forever in case there really was a
-        # problem.
-        end_time = time.time() + 5.0
-        do_join = True
-        while True:
-            ssh_server.stopped_event.wait(0.1)
-            if not ssh_server.active:
-                e = ssh_server.get_exception()
-                if e is not None:
-                    raise e
-            else:
-                # server is still actively running for requests
-                if time.time() >= end_time:
-                    sys.stderr.write("hung waiting for paramiko.Transport"
-                                     " %s to finish" % (ssh_server.getName(),))
-                    do_join = False
-                    break
-        if do_join:
-            # We already know the thread should have exited, so this should
-            # always be fast
-            ssh_server.join(1.0)
+        # Wait until the full conversation has been completed
+        # TODO: We could play around with timeouts here...
+        ssh_server.join()
 
     def wrap_for_latency(self):
         tcs = self.server.test_case_server

=== modified file 'bzrlib/tests/test_strace.py'
--- bzrlib/tests/test_strace.py	2010-09-01 18:43:13 +0000
+++ bzrlib/tests/test_strace.py	2010-09-01 19:38:55 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007-2010 Canonical Ltd
+# Copyright (C) 2007, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by

